/* VERSIONE CLIENT di List (JCF):
Implementare una lista collegata semplice di alberi binari di interi
Rif: (my)LinkedList, ListNode, BinaryTree e BinaryNOde
*/

import java.util.*;


public class ListofBtree {


  /************************************************************** 
  ** costruzione di un albero binario di interi random aventi
  ** al pi dim nodi di valore massimo maxvalue
  **************************************************************/ 
  
  public static BinaryTree<Integer> buildbtree(int dim, int maxvalue){
     	   Random r = new Random ();
	   // genera una dimensione compresa tra 0..dim
	   dim = r.nextInt(dim+1);
	   while (dim==0) dim = r.nextInt(dim+1);
	   BinaryTree<Integer> tree = buildbtreeR(dim, maxvalue);
	   return tree;
  }

  public static BinaryTree<Integer> buildbtreeR(int dim, int maxvalue){
		if (dim==0) return new BinaryTree<Integer>();
		Random r = new Random ();
		int dimleft=(dim-1)/2;
		return new BinaryTree<Integer>(r.nextInt(maxvalue),
				buildbtreeR(dimleft, maxvalue), buildbtreeR(dim-1-dimleft, maxvalue));		
  }




  public static void main (String[ ] args) {
     new ListofBtree().run();
  } // method main

  public void run(){

     	/**** GENERAZIONE LISTA di BinaryTrees ****/	
     	LinkedList list = new LinkedList( );
	BinaryTree<Integer> x;

	x = buildbtree(10,1000);
        list.insertOrd (x); // inserimento ordinato
	x = buildbtree(10,1000);
        list.insertOrd (x); // inserimento ordinato
	x = buildbtree(10,1000);
        list.insertOrd (x); // inserimento ordinato
	x = buildbtree(10,1000);
        list.insertOrd (x); // inserimento ordinato
	x = buildbtree(10,1000);
        list.insertOrd (x); // inserimento ordinato

        list.printList( );

        
  } // method run

} // class MyClassList
