/* VERSIONE CLIENT di List (JCF):
Implementare una lista collegate semplice di oggetti della classe MyClass
che supporta tra le altre le operazioni di inserimento ordinato di un nuovo
elemento e stampa della lista.
Focus sui metodi equals(), toString() e compareTo().
*/


import java.util.*;


public class MyClassList {


   public void insertOrd (MyClass x, List<MyClass> list) {
           if (list.isEmpty()) list.add(x);
           else { 
	     int index=0;
	     Iterator<MyClass> itr = list.iterator();
	     while (itr.hasNext()) {
	   	if ( ( (itr.next()).compareTo(x)) <0 ) index++;
		else break;
	     } // while
	     list.add(index, x);
	   } //else
   }// insertOrd 


  public static void main (String[ ] args) {
     new MyClassList().run();
  } // method main

  public void run(){

     	/**** GENERAZIONE LISTA di persone (istanze di MyClass) ****/	
     	List<MyClass> list = new LinkedList<MyClass>( );
	MyClass_byAge x;

	x = new MyClass_byAge("Carlo", "Rossi", 23);
        insertOrd (x, list); // inserimento ordinato
	x = new MyClass_byAge("Mario", "Bianchi", 20);
        insertOrd(x, list); // inserimento ordinato
	x = new MyClass_byAge("Luca", "Rossi", 18);
        insertOrd (x, list); // inserimento ordinato
	x = new MyClass_byAge("Giovanna", "Neri", 40);
        insertOrd (x, list); // inserimento ordinato
	x = new MyClass_byAge("Adele", "Gialli", 20);
        insertOrd (x, list); // inserimento ordinato

        System.out.println(list);

        
  } // method run

} // class MyClassList
